﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using ProcessSimulationInterfaces;

namespace ProcessSimulation_WpfApplication
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        IMotorProcessSystemSim processSystem = new ProcessSimulationSystem.MotorProcessSystem();
        ProcessCommunication.SocketCommunicator socketCom;
        ProcessCommunication.WebserviceComunicator webserverCom;

        //System.Threading.Thread sysThread;
        public MainWindow()
        {
            InitializeComponent();

            //System.Reflection.Assembly assembly = System.Reflection.Assembly.LoadFile(@"D:\_ 2017E_3_Sem\ProcessSimulation_NY\WpfApp4ProcessSimulation\bin\Debug\ProcessSimulationSystem.dll");
            //Type type = assembly.GetType("ProcessSimulationSystem.MotorProcessSystem");
            //var obj = (IMotorProcessSystemSim)Activator.CreateInstance(type);
            //obj.ToString();
            //sys = obj;


            this.ManualProcessInput.Value = (0);
            this.ProcessInput.Value = (0);
            this.ProcessOutput.Value = (0);
            this.ProcessxOutput.Value = (0);
            this.ProcessGoal.Value = (64);

            //sys.ProcessStateChangeEvent += new MotorProcessSystem.ProcessStateChangeEventType(UpdateUI);
            processSystem.SetProcessStateChangeEvent(new ProcessStateChangeEventType(UpdateUI));

        }

        private void UpdateUI(IMotorProcessSystem motorProcesSystem)
        {
            if (!this.Dispatcher.CheckAccess()) // Need to call again in UI task
            {
                this.Dispatcher.Invoke(new ProcessStateChangeEventType(UpdateUI), motorProcesSystem);    // indirekte recursion, men nu fra GUI tråd
                return;     // stop her, da metoden nu "gentages" (Invoke) fra GUI tråd  
            }

            // For visualizing processdata
            this.ProcessInput.Value = motorProcesSystem.GetProcessInput();
            this.ProcessOutput.Value = motorProcesSystem.GetProcessSpeed();
            this.ProcessxOutput.Value = motorProcesSystem.GetProcessPosition();

            double dif = this.ProcessxOutput.Value - (this.ProcessGoal.Value);
            if (dif < -0.001)
                this.ProcessGoal.Foreground = Brushes.Blue;
            else if (dif > 0.001)
                this.ProcessGoal.Foreground = Brushes.Red;
            else
                this.ProcessGoal.Foreground = Brushes.Green;

        }

        private void ButtonSetManualValue_Click(object sender, RoutedEventArgs e)
        {
            double inpAnalog = this.ManualProcessInput.Value;
            int inpDigital = (int)inpAnalog;
            processSystem.SetNewProcessInput(inpDigital);
        }

        private void StartProcessButton_Click(object sender, RoutedEventArgs e)
        {
            this.StartProcessButton.IsEnabled = false;
            int systemId = 0;
            int.TryParse(this.SystemId.Text, out systemId);
            processSystem.SystemId = systemId;
            this.SystemId.Text = systemId.ToString();
            this.SystemId.IsEnabled = false;
            processSystem.StartProcess();
        }

        private void StartSocketButton_Click(object sender, RoutedEventArgs e)
        {
            PanelProcessGoal.Visibility = Visibility.Hidden;
            PanelWebClient.Visibility = Visibility.Hidden;
            StartSocketButton.IsEnabled = false;
            SocketIp.IsEnabled = false;
            SocketPort.IsEnabled = false;
            socketCom = new ProcessCommunication.SocketCommunicator(processSystem, SocketIp.Text, int.Parse(SocketPort.Text.Trim()));
            socketCom.StartSocketServiceHandler();
        }

        private void StartWebClientButton_Click(object sender, RoutedEventArgs e)
        {
            PanelProcessGoal.Visibility = Visibility.Hidden;
            PanelSocket.Visibility = Visibility.Hidden;
            StartWebClientButton.IsEnabled = false;
            WebServerAddress.IsEnabled = false;
            webserverCom = new ProcessCommunication.WebserviceComunicator(processSystem, WebServerAddress.Text);

        }

        private void ResetProcessButton_Click(object sender, RoutedEventArgs e)
        {
            processSystem.ResetProcess();
        }
    }
}
